﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@

Sub Class_Globals
	Dim W As MLwifi
	Dim WScan As MLScan
	Dim WSCanDone As Boolean
	Dim ScanSuccess As Boolean = False
	
	Dim OldSSID As String = ""
	Dim NewSSID As String = ""
	Public CurrentSSID As String = ""
	
	Public IsInitialized As Boolean = False
	
	Dim ServerIp As String = "192.168.4.1"
	
	
	Type WifiStatusInfo(StatusValue As Int, _
							StatusString As String)
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Sub Initialize

	WSCanDone = False
	WifiScan(NewSSID)
	W.debug = True
	IsInitialized = True

End Sub

'TurnOn = true to turn on, false to turn off
Public Sub WiFiOn(TurnOn As Boolean)
		W.EnableWifi(TurnOn) 'True)
End Sub

Public Sub GetSSID As String
	Return W.WifiSSID
End Sub

public Sub GetStatus As WifiStatusInfo
	Dim StatusInfo As WifiStatusInfo
	StatusInfo.StatusValue = 0
	StatusInfo.Statusstring = "Data Disconnected"
	If W.isWifiEnabled Then StatusInfo.StatusValue = 128 : StatusInfo.StatusString = "WiFi Enabled" '& CRLF
	If W.isWifiConnected Then 
		StatusInfo.StatusValue = StatusInfo.StatusValue + 64
		StatusInfo.Statusstring = StatusInfo.Statusstring & ", WiFi Connected" & CRLF
	Else 
		StatusInfo.Statusstring = StatusInfo.Statusstring & CRLF
	End If
	If W.isOnline Then StatusInfo.StatusValue = StatusInfo.StatusValue + 32 : StatusInfo.Statusstring = StatusInfo.Statusstring & "Online" & CRLF
	If W.isOnlinePing4(ServerIp, 10000) Then StatusInfo.StatusValue = StatusInfo.StatusValue + 16 : StatusInfo.Statusstring = StatusInfo.Statusstring & "Ping OK" & CRLF
	If W.isMobileConnected Then StatusInfo.StatusValue = StatusInfo.StatusValue + 8 : StatusInfo.Statusstring = StatusInfo.Statusstring & "Data via Mobile"
	Return StatusInfo
End Sub

Public Sub WifiScan(SSID As String) As ResumableSub
	Try
		If Not(WSCanDone) Then
			WScan.startscan("WiFi", True)
			Wait For WiFi_ScanDone (Results() As String, Count As Int)
			Return CheckForAP(SSID)
		Else
			Log("Scan can only be done once")
		End If
	Catch
		Log("AA Scan: " & LastException)
	End Try
	WSCanDone = True
	Return False
End Sub

Sub CheckForAP(SSID As String) As Boolean

	Try
		For Each Entry In WScan.wifis 'list of Networks found
			Dim EntryInfo() As String = Regex.Split(",", Entry)
			If EntryInfo(0) = SSID Then
				Return True
			End If
		Next
	Catch
		Log("Check for AP: " & LastException)
	End Try
	Return False
End Sub

Public Sub WifiCheckAP(SSID As String)As ResumableSub
	If Not(WSCanDone) Then
		wait for WifiScan Complete '(result As Boolean)
	End If
	NewSSID = SSID
	WScan.updateWifiList

	Wait For WiFi_ScanDone(Results() As String, Count As Int) '15/12/20
	ScanSuccess = CheckForAP(SSID) 'Results, Count)

	Return ScanSuccess
End Sub

public Sub SetAP(APName As String, APPass As String, SecType As Int, Timeout As Int) As ResumableSub
	Try
		OldSSID = W.WifiSSID
		Log("Old SSID: " & OldSSID)
		Dim SAP1 As Boolean = True
		If (OldSSID <> APName) And (W.isSavedWifiAP(APName)) Then
			Log("Connect Saved")
			W.reconnectWifiAP(APName, Timeout)
			wait for W_ConnectionResult (SAP1 As Boolean)
		Else if OldSSID <> APName Then
			Log("Connect Save New")
			W.saveWifiAP(APName, SecType, APPass, True, Timeout)
			Log("Connect Save New 2")
			wait for W_ConnectionResult (SAP1 As Boolean)
		Else
			Log("already Connected")
			SAP1 = True
		End If
		If SAP1 Then CurrentSSID = APName
		Return SAP1
	Catch
		Log("SetAp error: " & LastException)
	End Try
	Return False
End Sub

public Sub ResetAP As ResumableSub
	'https://www.b4x.com/android/forum/threads/mlwifi-library-updated-to-v4-00.125051/page-2
'	I have to check my purpose is achieving or not by calling disconnectWiFiAP. 
'	However, I have to detect API, if API is 29 then call disconnectWifiAP else i have to call connectWifiAP("ssid", MLwifi.SECURITY_OPEN, "", timeout)), am i right?
	
	Dim p As Phone
	Dim AndroidVersion As Int = p.SdkVersion
	
	If AndroidVersion >= 29 Then
		Dim RAPResult As Boolean = w.disconnectWifiAP
		Return RAPResult
	Else
		Try
			If (OldSSID = "") Then Return False
			wait for (SetAP(OldSSID, "", 0, 30000)) complete (RAPResult As Boolean)
		Catch
			Log("ResetAP: " & LastException)
			RAPResult = False
		End Try
	End If
	Return RAPResult
End Sub
Sub ForgetAP(APName As String)
	Try
		If W.isSavedWifiAP(APName) Then W.removeWifiAP(APName)
	Catch
		Log("AA ForgetAP: " & LastException)
	End Try
End Sub